class SlackbotNotifier
  attr_reader :room, :message

  def initialize(room = 'general')
    @room = SlackbotNotifier.production ? room : SlackbotNotifier.development_room
  end

  def notify(message)
    @message = message
    http.request request
  end

  def uri
    @uri ||= URI "#{SlackbotNotifier.slackbot_url}&channel=%23#{room}"
  end

  def http
    @http ||= Net::HTTP.new(uri.host, uri.port).tap { |h| h.use_ssl = uri.scheme == 'https' }
  end

  def request
    @request ||= Net::HTTP::Post.new(uri.request_uri).tap do |r|
      r.body = message
      r.content_type = 'text/xml'
    end
  end

  class << self
    attr_accessor :slackbot_url, :development_room, :production
  end
end
